#!/usr/bin/perl

# mixed.pl Version 0.2.0 - Print Mixed Doubles Pairing
# Copyright (C) 2002-2010  dondalah721@yahoo.com (Dondalah)

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

srand;
$PREVEVENT = $PREVRND = -999;
while ($LN = <>)
   {
   chop($LN);
   @FLD = split(/ /,$LN);
   $LGTH = $#FLD;
   next if ($LGTH < 6);
   $EVENT = $FLD[0];
   $ROUND = $FLD[1];
   if ($EVENT != $PREVEVENT
      || $ROUND != $PREVRND)
      {
      printf "\nRound %3d\n", $ROUND;
      print  "\n             He  She        Him  Her\n";
      $PREVRND = $ROUND;
      $PREVEVENT = $EVENT;
      } # event break
   $COURT = $FLD[2];
   # shuffle the two sides
   $CHOICE = int(rand 2);
   if ($CHOICE == 0)
      {
      $HE    = $FLD[3] + 1;
      $SHE   = $FLD[4] + 1;
      $HIM   = $FLD[5] + 1;
      $HER   = $FLD[6] + 1;
      }
   else
      {
      $HE    = $FLD[5] + 1;
      $SHE   = $FLD[6] + 1;
      $HIM   = $FLD[3] + 1;
      $HER   = $FLD[4] + 1;
      }
   printf "Court %3d:  %3d  %3d   vs   %3d  %3d\n",
      $COURT, $HE, $SHE, $HIM, $HER;
   $PREVRND = $ROUND;
   $PREVEVENT = $EVENT;
   } # read loop
